import { X as m, ah as U, fw as E, dQ as q, _ as x, F as i, fx as Q, dh as T, di as X, a8 as _, dj as J, aB as K, fy as Y, fz as Z, dk as tt, e0 as et, dq as it, dr as nt } from "./ffa02e37.js";
import { createContext as ot, useRef as at, useContext as W, useMemo as o } from "react";
import { ContextContainerComp as rt } from "./1ee5599b.js";
import "react-dom";
const st = m.div`
  height: 100%;
  border: 1px solid ${(e) => e.$style.border};
  border-radius: ${(e) => e.$style.radius};
  padding: 3px ${(e) => e.$paddingWidth};
  rotate: ${(e) => e.$style.rotation};
  background-color: ${(e) => e.$style.background};
  ${(e) => e.$animationStyle}
`, ct = m.div`
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 3px;
`, dt = m.div`
  height: ${(e) => e.$autoHeight ? "100%" : "calc(100% - 32px)"};
`, lt = m.div` 
  height: 100%;
  display: flex;
  align-items: center;
  // justify-content: center;
`, gt = m.div`
  height: ${(e) => e.$autoHeight ? "auto" : "100%"};
  display: flex;
  flex-direction: ${(e) => e.$isHorizontal && !e.$isGrid ? "row" : "column"};
  height: 100%;
`, S = ot({
  horizontalWidth: "100%",
  minHorizontalWidth: "100px"
}), ht = (e) => {
  const {
    horizontalWidth: l,
    minHorizontalWidth: t
  } = W(S);
  return /* @__PURE__ */ i("div", {
    style: {
      width: l,
      minWidth: t || "0px"
    },
    children: /* @__PURE__ */ i(it, {
      ...e,
      emptyRows: 15,
      containerPadding: [4, 4],
      hintPlaceholder: nt
    })
  });
};
function mt({
  minHorizontalWidth: e,
  horizontalWidth: l,
  ...t
}) {
  const {
    itemIdx: c,
    offset: a,
    containerProps: d,
    autoHeight: w,
    scrollContainerRef: y,
    minHeight: p
  } = t;
  return /* @__PURE__ */ i(S.Provider, {
    value: {
      horizontalWidth: l,
      minHorizontalWidth: e
    },
    children: /* @__PURE__ */ i(ht, {
      layout: d.layout,
      items: tt(d.items),
      positionParams: d.positionParams,
      dispatch: c === a ? d.dispatch : x.noop,
      style: {
        height: "100%",
        // in case of horizontal mode, minHorizontalWidth is 0px
        width: e || "100%",
        backgroundColor: "transparent"
        // flex: "auto",
      },
      autoHeight: w,
      isDroppable: c === a,
      isDraggable: c === a,
      isResizable: c === a,
      isSelectable: c === a,
      scrollContainerRef: y,
      overflow: "hidden",
      minHeight: p,
      enableGridLines: !0
    })
  });
}
function yt(e) {
  const {
    comp: l
  } = e, t = l.children, c = at(null), a = W(U), d = a.isDragging, [w, y] = E(0, d), p = o(() => t.dynamicHeight.getView(), [t.dynamicHeight]), V = o(() => t.heightUnitOfRow.getView(), [t.heightUnitOfRow]), v = o(() => t.container.getView(), [t.container]), R = o(() => t.itemIndexName.getView(), [t.itemIndexName]), I = o(() => t.itemDataName.getView(), [t.itemDataName]), {
    data: P,
    itemCount: z
  } = o(() => q(t.noOfRows.getView()), [t.noOfRows]), u = o(() => t.autoHeight.getView(), [t.autoHeight]), D = o(() => t.scrollbars.getView(), [t.scrollbars]), b = o(() => t.horizontal.getView(), [t.horizontal]), O = o(() => t.minHorizontalWidth.getView(), [t.minHorizontalWidth]), h = o(() => Math.max(1, t.noOfColumns.getView()), [t.noOfColumns]), r = o(() => {
    const s = t.pagination.getView(), g = s.total || z;
    let f = s.current, n = (f - 1) * s.pageSize;
    const $ = Math.max(0, Math.min(s.pageSize, g - n));
    return {
      pagination: {
        ...s,
        current: f,
        total: g
      },
      offset: n,
      currentPageSize: $,
      total: g
    };
  }, [t.pagination, z]), C = t.style.getView(), M = t.animationStyle.getView(), L = l.realSimpleContainer().children.layout.getView(), H = r.currentPageSize > 0 && (x.isEmpty(L) || a.isDragging), k = H ? 1 : Math.floor((r.currentPageSize + h - 1) / h), N = H ? "100%" : p ? "auto" : V * 44 + "px", j = d && u ? w + "px" : "100%", F = x.range(0, k).map((s) => /* @__PURE__ */ i("div", {
    style: {
      height: N,
      width: "100%"
    },
    children: /* @__PURE__ */ i(lt, {
      children: x.range(0, h).map((f) => {
        const n = s * h + f + r.offset;
        if (n >= r.total || n >= r.offset + r.pagination.pageSize || H && n > r.offset)
          return /* @__PURE__ */ i("div", {
            style: {
              flex: "auto"
            }
          }, n);
        const $ = v({
          [R]: n,
          [I]: Q(P, n)
        }, String(n)).getView(), A = () => {
          l.children.container.dispatch(et(rt.batchDeleteAction([String(n)])));
        };
        return /* @__PURE__ */ i(mt, {
          itemIdx: n,
          offset: r.offset,
          containerProps: $,
          autoHeight: d || p,
          scrollContainerRef: c,
          minHeight: j,
          unMountFn: A,
          horizontalWidth: `${100 / h}%`,
          minHorizontalWidth: b ? O : void 0
        }, n);
      })
    })
  }, s)), G = a.getAppSettings().maxWidth, B = T(G) ? "4px" : "16px";
  return /* @__PURE__ */ i(X.Provider, {
    value: C.background,
    children: /* @__PURE__ */ _(st, {
      $style: C,
      $paddingWidth: B,
      $animationStyle: M,
      children: [/* @__PURE__ */ i(dt, {
        ref: c,
        $autoHeight: u,
        children: /* @__PURE__ */ i(J, {
          style: {
            height: u ? "auto" : "100%",
            margin: "0px",
            padding: "0px"
          },
          hideScrollbar: !D,
          children: /* @__PURE__ */ i(K, {
            onResize: (s, g) => {
              g && y(g);
            },
            observerOptions: {
              box: "border-box"
            },
            render: () => /* @__PURE__ */ i(gt, {
              $isHorizontal: b,
              $isGrid: h > 1,
              $autoHeight: u,
              children: F
            })
          })
        })
      }), /* @__PURE__ */ i(ct, {
        children: /* @__PURE__ */ i(Y, {
          size: "small",
          itemRender: Z,
          ...r.pagination
        })
      })]
    })
  });
}
export {
  yt as ListView
};
