import { X as l, dt as w, Y as o, a5 as x, aA as p, a4 as s, du as f, Z as g, dv as y, az as $, U as b, F as a, dw as C, a8 as r, G as h, a9 as n, aa as i, ah as u, ab as v, ac as S, ae as A, ad as k, av as V, aw as T, ax as z, an as H, ap as F, ao as M } from "./ffa02e37.js";
import { useContext as c } from "react";
import { MarginControl as P } from "./f801f779.js";
import { PaddingControl as B } from "./1ed2dade.js";
import "react-dom";
const W = (t) => V`
    border-radius: ${t.radius ? t.radius : "4px"};
    border: ${t.borderWidth ? t.borderWidth : "0px"} solid ${t.border};
    color: ${t.text};
    text-transform:${t.textTransform} !important;
    text-decoration:${t.textDecoration} !important;
    background-color: ${t.background};
    .markdown-body a {
      color: ${t.links};
    }
    .markdown-body {
      margin: ${t.margin} !important;	
      padding: ${t.padding};	
      width: ${T(t.margin)};	
      font-family: ${t.fontFamily} !important;
      font-style:${t.fontStyle} !important;
      font-size: ${t.textSize} !important;
      // height: ${z(t.margin)};
      h1 {
        line-height: 1.5;
      }
      h5 {
        line-height: 2.2;
      }
    }

    .markdown-body {
      &,
      p,
      div,
      h1,
      h2,
      h3,
      h4,
      h5,
      h6 {
        color: ${t.text};
        font-weight: ${t.textWeight} !important;
      }
      img,
      pre {
        background-color: ${t.background};
        code {
          color: #000000;
        }
      }
    }
  `, j = l.div`
  height: 100%;
  overflow: auto;
  margin: 0;
  ${(t) => t.$animationStyle}
  ${(t) => t.$type === "text" && "white-space:break-spaces;line-height: 1.9;"};
  ${(t) => t.$styleConfig && W(t.$styleConfig)}
  display: flex;
  font-size: 13px;
  ${w};
  overflow-wrap: anywhere;
  .markdown-body {
    overflow-wrap: anywhere;
  }
`, D = l(H)`
  transform: rotate(90deg);
`, E = l(F)`
  transform: rotate(90deg);
`, N = l(M)`
  transform: rotate(90deg);
`, R = [{
  label: "Markdown",
  value: "markdown"
}, {
  label: o("text"),
  value: "text"
}], U = [{
  label: /* @__PURE__ */ a(D, {}),
  value: "flex-start"
}, {
  label: /* @__PURE__ */ a(N, {}),
  value: "center"
}, {
  label: /* @__PURE__ */ a(E, {}),
  value: "flex-end"
}];
let d = function() {
  const t = {
    text: x("text", o("textShow.text", {
      name: "{{currentUser.name}}"
    })),
    autoHeight: p,
    type: s(R, "markdown"),
    horizontalAlignment: f(),
    verticalAlignment: s(U, "center"),
    style: g(y),
    animationStyle: g($),
    margin: P,
    padding: B
  };
  return new b(t, (e) => {
    const m = e.text.value;
    return /* @__PURE__ */ a(j, {
      $animationStyle: e.animationStyle,
      $type: e.type,
      $styleConfig: e.style,
      style: {
        justifyContent: e.horizontalAlignment,
        alignItems: e.autoHeight ? "center" : e.verticalAlignment,
        textAlign: e.horizontalAlignment,
        rotate: e.style.rotation
      },
      children: e.type === "markdown" ? /* @__PURE__ */ a(C, {
        children: m
      }) : m
    });
  }).setPropertyViewFn((e) => /* @__PURE__ */ r(h, {
    children: [/* @__PURE__ */ r(n, {
      name: i.basic,
      children: [e.type.propertyView({
        label: o("value"),
        tooltip: o("textShow.valueTooltip"),
        radioButton: !0
      }), e.text.propertyView({})]
    }), ["logic", "both"].includes(c(u).editorModeStatus) && /* @__PURE__ */ a(n, {
      name: i.interaction,
      children: v(e)
    }), ["layout", "both"].includes(c(u).editorModeStatus) && /* @__PURE__ */ r(h, {
      children: [/* @__PURE__ */ r(n, {
        name: i.layout,
        children: [e.autoHeight.getPropertyView(), !e.autoHeight.getView() && e.verticalAlignment.propertyView({
          label: o("textShow.verticalAlignment"),
          radioButton: !0
        }), e.horizontalAlignment.propertyView({
          label: o("textShow.horizontalAlignment"),
          radioButton: !0
        })]
      }), /* @__PURE__ */ a(n, {
        name: i.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ a(n, {
        name: i.animationStyle,
        hasTooltip: !0,
        children: e.animationStyle.getPropertyView()
      })]
    })]
  })).build();
}();
d = class extends d {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const Y = S(d, [new A("text", o("textShow.textDesc")), k]);
export {
  Y as TextComp
};
