import { av as n, cT as h, X as b, cU as c, P as u, bI as x, cV as k, cW as f, Z as a, c2 as m, c3 as $, a4 as s, N as p, cX as v, az as g, U as C, F as i, ac as S, ae as w, Y as B, bL as W, cY as I, bS as F } from "./ffa02e37.js";
import { SelectInputValidationChildren as V, useSelectInputValidate as D, selectDivRefMethods as E, SelectInputInvalidConfig as R } from "./9e91b3fc.js";
import { formDataChildren as z } from "./35ed5374.js";
import { RadioLayoutOptions as L, RadioPropertyView as O } from "./f61efaea.js";
import "react";
import { fixOldInputCompData as T } from "./b871797b.js";
import "react-dom";
const y = (e) => n`
    &,
    .ant-checkbox-wrapper:not(.ant-checkbox-wrapper-disabled) {
      color: ${e.staticText};
      max-width: calc(100% - 8px);

      span:not(.ant-checkbox) {
        ${h};
      }

      .ant-checkbox .ant-checkbox-checked > .ant-checkbox-inner {
        border-color: ${e.checkedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }

      .ant-checkbox:not(.ant-checkbox-checked) > .ant-checkbox-inner{
        border-color: ${e.uncheckedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }

      .ant-checkbox-checked {
        .ant-checkbox-inner {
          background-color: ${e.checkedBackground};
          border-color: ${e.checkedBorder};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};

          &::after {
            border-color: ${e.checked};
          }
        }

        &::after {
          border-color: ${e.checkedBorder};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};
          border-radius: ${e.radius};
        }
      }
      
      .ant-checkbox-inner {
        background-color: ${e.uncheckedBackground};
        border-radius: ${e.radius};
        border-color: ${e.checkedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    
      &:hover .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#fff"};
      }

      &:hover .ant-checkbox-checked .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#ffff"};
      }

      &:hover .ant-checkbox-inner,
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input:focus + .ant-checkbox-inner {
        border-color: ${e.checkedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    }

    

    .ant-checkbox-group-item {
      font-family:${e.fontFamily};
      font-size:${e.textSize};
      font-weight:${e.textWeight};
      font-style:${e.fontStyle};
      text-transform:${e.textTransform};
      text-decoration:${e.textDecoration};
    }
    .ant-checkbox-wrapper {
      padding: ${e.padding};
      .ant-checkbox-inner,
      .ant-checkbox-checked::after {
        border-radius: ${e.radius};
      }
    }
  `, M = b(I)`
  min-height: 32px;
  ${(e) => e.$style && y(e.$style)}
  ${(e) => {
  if (e.$layout === "horizontal")
    return n`
        display: flex;
        align-items: center;
        flex-wrap: wrap;
      `;
  if (e.$layout === "vertical")
    return n`
        display: flex;
        flex-direction: column;
      `;
  if (e.$layout === "auto_columns")
    return n`
        break-inside: avoid;
        columns: 160px;
      `;
}}
`;
let t = function() {
  const e = {
    defaultValue: c("defaultValue"),
    value: c("value"),
    label: u,
    disabled: x,
    onEvent: k,
    options: f,
    style: a(m),
    labelStyle: a($.filter((o) => ["accent", "validate"].includes(o.name) === !1)),
    layout: s(L, "horizontal"),
    viewRef: p,
    inputFieldStyle: a(v),
    animationStyle: a(g),
    ...V,
    ...z
  };
  return new C(e, (o) => {
    const [d, l] = D(o);
    return o.label({
      required: o.required,
      style: o.style,
      labelStyle: o.labelStyle,
      inputFieldStyle: o.inputFieldStyle,
      animationStyle: o.animationStyle,
      children: /* @__PURE__ */ i(M, {
        ref: o.viewRef,
        disabled: o.disabled,
        value: o.value.value,
        $style: o.inputFieldStyle,
        $layout: o.layout,
        options: o.options.filter((r) => r.value !== void 0 && !r.hidden).map((r) => ({
          label: r.label,
          value: r.value,
          disabled: r.disabled
        })),
        onChange: (r) => {
          l(r);
        }
      }),
      ...d
    });
  }).setPropertyViewFn((o) => /* @__PURE__ */ i(O, {
    ...o
  })).setExposeMethodConfigs(E).build();
}();
t = F(t, T);
const Y = S(t, [new w("value", B("selectInput.valueDesc")), R, ...W]);
export {
  Y as CheckboxComp,
  y as getStyle
};
